module.exports.extractFromJson = function (DataSet, expression,option="") {

    if (!DataSet) {
        return;
    }
    if (!expression) {
        return;
    }
    var expression_split = expression.split(".");
    if (expression_split && expression_split.length > 1) {
        var DataSetName = expression_split[0];
        var rootNode = DataSet[DataSetName];
        expression_split.shift();
        expression_split.forEach((key, index) => {
            rootNode = findData(rootNode, key,option);
        })
        return rootNode;
    } else {
        return;
    }
}
//setName1.obj(aa|o=>a,k=>kk) "|" 前面的代表需要将自身换名字   "|"后面代表需要将子节点换名字
//setName2.arr.[k(),j]
var findData = function (node, key,option) {

    var data;
    var keyList = [];
    if (key.startsWith("[")) {
        keyList =  key.substr(1, key.length - 2).split(",");
    } else {
        keyList.push(key);
    }
    //[{name:"",age:""},{name:"",age:""}]
    //判断是[] 还是 {}
    if (node instanceof Array) {
        data = [];
        node.forEach((item, index) => {
            if (item instanceof Array) {
                var record = [];
                item.forEach((subItem, index) => {
                    record.push(findData(subItem, key,option));
                })
                data.push(record);
            } else {
                if (keyList.length > 1) {
                    var recod = {};
                    keyList.forEach((it, ind) => {
                        //TODO NICK
                        recod[it] = item[it];
                    });
                    data.push(recod);
                } else {
                    if(option.indexOf("nn")>=0){
                        var d = {};
                        d[keyList[0]]=item[keyList[0]];
                        data.push(d);
                    }else{
                        data.push(item[keyList[0]])
                    }
                }
            }
        })
    } else {
        data = {};
        keyList.forEach((it, ind) => {
            var val = node[it];
            if (typeof val === "object") {
                if(option.indexOf("nn")>=0&&!(val instanceof Array)){
                    var v = {};
                    //TODO NICK
                    v[it] = val;
                    data = v;
                }else{
                    data = val;
                }                
            } else {
                //TODO NICK
                data[it] = val;
            }
        });
    }
    //console.log(data);
    return data;
}


var TData =
    {
        "setName1": { 
            "name": "robin", "age": 18, 
            "obj": { "o": "o1", "b": "b1" }, 
            "arr": [{ "k": "k1", "j": "j1" }, { "k": "k2", "j": "j2" }],
            "arr2":[
                     [ { "k": "k1", "j": "j1" }, { "k": "k2", "j": "j2" }],
                     [{ "k": {"a":"a1"}, "j": "j1" }, { "k": "k2", "j": "j2" }]
                   ]
         },
        "setName2": [
            { "name": "robin1", "age": 18, "type": 1, "obj": { "o": "o1" }, "arr": [{ "k": { "a": "a1" }, "j": "j1" }, { "k": "k2", "j": "j2" }] },
            { "name": "robin2", "age": 19, "type": 1, "obj": { "o": "o2" }, "arr": [{ "k": "k1", "j": "j1" }, { "k": "k2", "j": "j2" }] },
            { "name": "robin3", "age": 20, "type": 1, "obj": { "o": "o3" }, "arr": [{ "k": "k1", "j": "j1" }, { "k": "k2", "j": "j2" }] }
        ]
    }

console.log("setName1.obj=>", this.extractFromJson(TData, "setName1.obj(o=>a)"));
// console.log("setName1.obj=>", this.extractFromJson(TData, "setName1.obj",'nn'));
// console.log("setName1.obj.o=>", this.extractFromJson(TData, "setName1.obj.o"));
// console.log("setName1.arr=>", this.extractFromJson(TData, "setName1.arr"));


// console.log("setName1.arr.k=>", this.extractFromJson(TData, "setName1.arr.k"));
// console.log("setName1.arr.k=>", this.extractFromJson(TData, "setName1.arr.k",'nn'));

// console.log("setName1.arr2=>", this.extractFromJson(TData, "setName1.arr2"));
// console.log("setName1.arr2.k=>", this.extractFromJson(TData, "setName1.arr2.k"));
// console.log("setName1.arr2.k=>", JSON.stringify(this.extractFromJson(TData, "setName1.arr2.k",'nn')));
// console.log("setName1.arr2.k.a=>", this.extractFromJson(TData, "setName1.arr2.k.a"));
// console.log("setName1.arr2.[k,j]=>", this.extractFromJson(TData, "setName1.arr2.[k,j]","nn"));

// console.log("setName2.obj=>", this.extractFromJson(TData, "setName2.obj"));
// console.log("setName2.obj.o=>", this.extractFromJson(TData, "setName2.obj.o"));
// console.log("setName2.arr=>", this.extractFromJson(TData, "setName2.arr"));
// console.log("setName2.arr.k=>", this.extractFromJson(TData, "setName2.arr.k"));
console.log("setName2.arr.[k,j]=>", this.extractFromJson(TData, "setName2.arr.[k,j]"));
// console.log("setName2.arr.k.a=>", this.extractFromJson(TData, "setName2.arr.k.a"));
// console.log("setName2.name  =>", this.extractFromJson(TData, "setName2.name"));
// console.log("[setName2.name,option='nn']  =>", this.extractFromJson(TData, "setName2.name","nn,"));
// console.log("setName2.[name,age]  =>", this.extractFromJson(TData, "setName2.[name,age]"));
// console.log("setName2.[name,arr]=>", this.extractFromJson(TData, "setName2.[name,arr]"));
